# -*- coding: utf-8 -*-
#
# Copyright (C) 2010 Vadim Alimguzhin <darth@darth.su>, Nazar Vinnichuk <UX.ISCo@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

import rb, rhythmdb
import gobject
import gconf
import gtk
import vkapi_helpers
import VkBaseSource

class ListsSource(rb.BrowserSource, VkBaseSource.VkBaseSource):
    plugin = gobject.property()
    #__client = gconf.client_get_default()
    
    def __init__(self):
        rb.BrowserSource.__init__(self, name=_("VkontakteMy"))
        self.initialised = False
    
    def do_impl_deactivate(self):
        rb.BrowserSource.do_impl_deactivate(self)
    
    def do_impl_activate(self):
        if not self.initialised:
            self.initialise()
            rb.BrowserSource.do_impl_activate(self)
    
    def initialise(self):
        if not self.initialised:
            self.entry_view = self.get_entry_view()
            self.actions_list = (
            #([0]'actionname', [1]_('Action Human name'), [2]_('Action tooltip'), [3]'action-icon', [4] actionfunction, [5] is_per_item,  [6]is_in_toolbar, [7] is_toogle_action,),
            #('', _(''), _(''), '', , , , ),
            ('VkontakteDeleteFav', _('_Delete'), _('Deletes song from"My Music" in vkontakte'), 'gtk-delete',  self.del_from_favs, True, True, False ),
            
#            ('', _(''), _(''), '', , , , ),
#            ('', _(''), _(''), '', , , , ),
#            ('', _(''), _(''), '', , , , ),
#            ('', _(''), _(''), '', , , , ),
#            ('', _(''), _(''), '', , , , ),
#            ('', _(''), _
             )
            
            self.popup_ui = """
<ui>
  <popup name="VkontakteListMyFavsViewPopup">
    <menuitem name="AddToQueueLibraryPopup" action="AddToQueue"/>
    <menuitem name="VkontakteDeleteFav" action="VkontakteDeleteFav"/>
    <separator/>
    <menuitem name="BrowseGenreLibraryPopup" action="BrowserSrcChooseGenre"/>
    <menuitem name="BrowseArtistLibraryPopup" action="BrowserSrcChooseArtist"/>
    <menuitem name="BrowseAlbumLibraryPopup" action="BrowserSrcChooseAlbum"/>
    <separator/>
    <menuitem name="PropertiesLibraryPopup" action="MusicProperties"/>
  </popup>
</ui>
"""
            self.status = None
            self.initialise_actions()
            
            
            #self.get_entry_view().set_sorting_type(self.__client.get_string("/apps/rhythmbox/plugins/vkontakte/sorting"))
            
            self.refetch_my_music()
            self.initialised = True
    
    def do_impl_delete_thyself(self):
        #self.__client.set_string("/apps/rhythmbox/plugins/vkontakte/sorting", self.get_entry_view().get_sorting_type())
        rb.BrowserSource.do_impl_delete_thyself(self)
        
    def do_impl_show_entry_popup(self):
        self.show_source_popup("VkontakteListMyFavsViewPopup")
     
    def do_impl_get_ui_actions(self):
        return self.ui_actions
    
    def do_impl_get_status(self):
        if self.status is not None:
            return (self.status)
        else:
            return (self.get_property('query-model').compute_status_normal("Found %d result", "Found %d results"), "", 1)
    
    def fmt_vk_error(self, code, msg, params):
        return 'Error (%d): %s (request params: %s)' % (code, msg, params)
    
    def load_ok(self, tracks):
        shell = self.get_property('shell')
        db = shell.get_property('db')
        entry_type = self.get_property('entry-type')
        query_model = self.get_property('query-model')
        for track in tracks:
            try:
                vkapi_helpers.entry_from_api_response(db, entry_type, track)
            except Exception, e:
                print 'exception: %s' % e
        db.commit()
        self.status = None
        self.notify_status_changed()
    
    def load_error(self, code, msg, rp):
        self.status = ("Can't fetch music list: %s" % self.fmt_vk_error(code, msg, rp), "", 1)
        self.notify_status_changed()
    
    def del_from_favs(self):
        vk_queue = self.props.plugin.vk_queue
        db = self.get_property('shell').get_property('db')
        for entry in self.entry_view.get_selected_entries():
            r = vkapi_helpers.api_response_from_entry(db, entry)
            
            params = {"aid":r["aid"], "oid":r["owner_id"]}
            vk_queue.add("audio.delete", params, fok = self.del_from_favs_ok, \
                         ferror = self.del_from_favs_error)
        self.status = ("Deleting song....", "", -1)
        self.notify_status_changed()
    
    def del_from_favs_ok(self, data):
        self.status = ("Song deleted", "", 1)
        self.notify_status_changed()
    
    def del_from_favs_error(self, code, msg, rp):
        self.status = ("Can't delete song: %s" % self.fmt_vk_error(code, msg, rp), "", 1)
        self.notify_status_changed()
    
    def refetch_my_music(self):
        self.props.plugin.vk_queue.add("audio.get", fok = self.load_ok, \
                                       ferror = self.load_error)
        self.status = ("Loading...", "", -1)


gobject.type_register(ListsSource)

